//---------------------------------------------------------------------
// Fǂ
//---------------------------------------------------------------------
#include <windows.h>
#include <tchar.h>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#include "filter.h"

//---------------------------------------------------------------------
// tB^\̒`
//---------------------------------------------------------------------
#define TRACK_N 6 // gbNo[̐
TCHAR *track_name[] = { ":+w", ":+h", ":+w", ":+h", ":+w", ":+h" };
int track_default[] = { 0, 0, 0, 0, 0, 0  };
int track_s[] = { 0, 0, 0, 0, 0, 0 };
int track_e[] = { 256, 256, 256, 256, 256, 256 };

#define CHECK_N 3 // `FbN{bNX̐
TCHAR *check_name[] = { ":ڂ", ":ڂ", ":ڂ" };
int check_default[] = { 0, 0, 0 };

FILTER_DLL filter = {
    FILTER_FLAG_EX_INFORMATION,
    0,0,
    "Fǂ",
    TRACK_N,
    track_name,
    track_default,
    track_s, track_e,
    CHECK_N,
    check_name,
    check_default,
    func_proc,
    NULL,
    NULL,
    NULL,
    NULL,
    NULL, NULL,
    NULL,
    0,
    "Fǂ ver0.0.1 by ۂ",
    NULL,
    NULL,
};

//---------------------------------------------------------------------
// tB^\̂̃|C^n֐
//---------------------------------------------------------------------
EXTERN_C FILTER_DLL __declspec(dllexport) * __stdcall GetFilterTable( void )
{
    return &filter;
}

//---------------------------------------------------------------------
// Oa
//---------------------------------------------------------------------
inline int satura8bit( const int &a )
{
    if( a <   0 ) return 0;
    if( a > 255 ) return 255;
    return a;
}

//---------------------------------------------------------------------
// Xbh:YC48 -> RGB
//---------------------------------------------------------------------
void __attribute__((force_align_arg_pointer)) thread_yc2rgb( int thread_id, int thread_num, void *param1, void *param2 )
{
    //const FILTER *fp              = (FILTER *)param1;
    const FILTER_PROC_INFO *fpip  = (FILTER_PROC_INFO *)param2;

    const int w       = fpip->w;
    const int h       = fpip->h;
    const int max_w   = fpip->max_w;
    const int padding = max_w - w;

    // Xbhc̃TCY葽璲
    if( thread_num > h ) thread_num = h;
    if( thread_id >= thread_num || thread_id < 0 ) return;

    // Xbh̉摜郉CvZ
    const int y_start = (h *  thread_id     ) / thread_num;
    const int y_end   = (h * (thread_id + 1)) / thread_num;

    // |C^
    const PIXEL_YC *ycp = fpip->ycp_edit + max_w * y_start;
    PIXEL *rgb = (PIXEL *)fpip->ycp_temp + max_w * y_start;

    // [v
    for( int y = y_start; y < y_end; y++ )
    {
        for( int x = 0; x < w; x++ )
        {
            int Y, Cb, Cr;
            int R, G, B;

            Y  = ycp->y;
            Cb = ycp->cb;
            Cr = ycp->cr;

            R = satura8bit( (255*Y           + 358*Cr + 2048) >> 12 );
            G = satura8bit( (255*Y -  88*Cb -  182*Cr + 2048) >> 12 );
            B = satura8bit( (255*Y + 452*Cb           + 2048) >> 12 );

            rgb->r = R;
            rgb->g = G;
            rgb->b = B;

            ycp++;
            rgb++;
        }
        ycp += padding;
        rgb += padding;
    }
}

//---------------------------------------------------------------------
// Xbh:RAGAB̊eCʁXɂڂ
//---------------------------------------------------------------------
void __attribute__((force_align_arg_pointer)) thread_blur( int thread_id, int thread_num, void *param1, void *param2 )
{
    const FILTER *fp              = (FILTER *)param1;
    const FILTER_PROC_INFO *fpip  = (FILTER_PROC_INFO *)param2;

    const int w       = fpip->w;
    const int h       = fpip->h;
    const int max_w   = fpip->max_w;

    // Xbh(c-2)葽璲
    if( thread_num > (h-2) ) thread_num = (h-2);
    if( thread_id >= thread_num || thread_id < 0 ) return;

    // Xbh̉摜郉CvZ
    const int y_start = ((h-2) *  thread_id     ) / thread_num + 1;
    const int y_end   = ((h-2) * (thread_id + 1)) / thread_num + 1;

    const BOOL bRed   = !!fp->check[0];
    const BOOL bGreen = !!fp->check[1];
    const BOOL bBlue  = !!fp->check[2];

    // 1Ԗڂ̃XbhȂԏ̃C
    if( thread_id == 0 )
    {
        const PIXEL *rgb_src = (PIXEL *)fpip->ycp_edit;
        PIXEL *rgb_dst = (PIXEL *)fpip->ycp_temp;
        // ԍ
        {
            rgb_dst->b = ( bBlue ) ?
                        (
                            (  rgb_src[      -0].b
                             + rgb_src[      +0].b
                             + rgb_src[      +1].b
                             + rgb_src[      -0].b
                             + rgb_src[       1].b
                             + rgb_src[ max_w-0].b
                             + rgb_src[ max_w+0].b
                             + rgb_src[ max_w+1].b
                            ) * 455
                         + rgb_src[       0].b * 456
                         + 2048
                        ) >> 12
                        : rgb_src[0].b;
            rgb_dst->g = ( bGreen ) ?
                        (
                            (  rgb_src[      -0].g
                             + rgb_src[      +0].g
                             + rgb_src[      +1].g
                             + rgb_src[      -0].g
                             + rgb_src[       1].g
                             + rgb_src[ max_w-0].g
                             + rgb_src[ max_w+0].g
                             + rgb_src[ max_w+1].g
                            ) * 455
                         + rgb_src[       0].g * 456
                         + 2048
                        ) >> 12
                        : rgb_src[0].g;
            rgb_dst->r = ( bRed ) ?
                        (
                            (  rgb_src[      -0].r
                             + rgb_src[      +0].r
                             + rgb_src[      +1].r
                             + rgb_src[      -0].r
                             + rgb_src[       1].r
                             + rgb_src[ max_w-0].r
                             + rgb_src[ max_w+0].r
                             + rgb_src[ max_w+1].r
                            ) * 455
                         + rgb_src[       0].r * 456
                         + 2048
                        ) >> 12
                        : rgb_src[0].r;
            rgb_src++;
            rgb_dst++;
        }
        // [v
        for( int x = 1; x < w-1; x++ )
        {
            rgb_dst->b = ( bBlue ) ?
                        (
                            (  rgb_src[      -1].b
                             + rgb_src[      +0].b
                             + rgb_src[      +1].b
                             + rgb_src[      -1].b
                             + rgb_src[       1].b
                             + rgb_src[ max_w-1].b
                             + rgb_src[ max_w+0].b
                             + rgb_src[ max_w+1].b
                            ) * 455
                         + rgb_src[       0].b * 456
                         + 2048
                        ) >> 12
                        : rgb_src[0].b;
            rgb_dst->g = ( bGreen ) ?
                        (
                            (  rgb_src[      -1].g
                             + rgb_src[      +0].g
                             + rgb_src[      +1].g
                             + rgb_src[      -1].g
                             + rgb_src[       1].g
                             + rgb_src[ max_w-1].g
                             + rgb_src[ max_w+0].g
                             + rgb_src[ max_w+1].g
                            ) * 455
                         + rgb_src[       0].g * 456
                         + 2048
                        ) >> 12
                        : rgb_src[0].g;
            rgb_dst->r = ( bRed ) ?
                        (
                            (  rgb_src[      -1].r
                             + rgb_src[      +0].r
                             + rgb_src[      +1].r
                             + rgb_src[      -1].r
                             + rgb_src[       1].r
                             + rgb_src[ max_w-1].r
                             + rgb_src[ max_w+0].r
                             + rgb_src[ max_w+1].r
                            ) * 455
                         + rgb_src[       0].r * 456
                         + 2048
                        ) >> 12
                        : rgb_src[0].r;
            rgb_src++;
            rgb_dst++;
        }
        // ԉE
        {
            rgb_dst->b = ( bBlue ) ?
                        (
                            (  rgb_src[      -1].b
                             + rgb_src[      +0].b
                             + rgb_src[      +0].b
                             + rgb_src[      -1].b
                             + rgb_src[       0].b
                             + rgb_src[ max_w-1].b
                             + rgb_src[ max_w+0].b
                             + rgb_src[ max_w+0].b
                            ) * 455
                         + rgb_src[       0].b * 456
                         + 2048
                        ) >> 12
                        : rgb_src[0].b;
            rgb_dst->g = ( bGreen ) ?
                        (
                            (  rgb_src[      -1].g
                             + rgb_src[      +0].g
                             + rgb_src[      +0].g
                             + rgb_src[      -1].g
                             + rgb_src[       0].g
                             + rgb_src[ max_w-1].g
                             + rgb_src[ max_w+0].g
                             + rgb_src[ max_w+0].g
                            ) * 455
                         + rgb_src[       0].g * 456
                         + 2048
                        ) >> 12
                        : rgb_src[0].g;
            rgb_dst->r = ( bRed ) ?
                        (
                            (  rgb_src[      -1].r
                             + rgb_src[      +0].r
                             + rgb_src[      +0].r
                             + rgb_src[      -1].r
                             + rgb_src[       0].r
                             + rgb_src[ max_w-1].r
                             + rgb_src[ max_w+0].r
                             + rgb_src[ max_w+0].r
                            ) * 455
                         + rgb_src[       0].r * 456
                         + 2048
                        ) >> 12
                        : rgb_src[0].r;
        }
    }

    // C[v
    for( int y = y_start; y < y_end; y++ )
    {
        // |C^
        const PIXEL *rgb_src = (PIXEL *)fpip->ycp_edit + max_w * y;
        PIXEL *rgb_dst = (PIXEL *)fpip->ycp_temp + max_w * y;
        // [
        {
            rgb_dst->b = ( bBlue ) ?
                        (
                            (  rgb_src[-max_w-0].b
                             + rgb_src[-max_w+0].b
                             + rgb_src[-max_w+1].b
                             + rgb_src[      -0].b
                             + rgb_src[       1].b
                             + rgb_src[ max_w-0].b
                             + rgb_src[ max_w+0].b
                             + rgb_src[ max_w+1].b
                            ) * 455
                         + rgb_src[       0].b * 456
                         + 2048
                        ) >> 12
                        : rgb_src[0].b;
            rgb_dst->g = ( bGreen ) ?
                        (
                            (  rgb_src[-max_w-0].g
                             + rgb_src[-max_w+0].g
                             + rgb_src[-max_w+1].g
                             + rgb_src[      -0].g
                             + rgb_src[       1].g
                             + rgb_src[ max_w-0].g
                             + rgb_src[ max_w+0].g
                             + rgb_src[ max_w+1].g
                            ) * 455
                         + rgb_src[       0].g * 456
                         + 2048
                        ) >> 12
                        : rgb_src[0].g;
            rgb_dst->r = ( bRed ) ?
                        (
                            (  rgb_src[-max_w-0].r
                             + rgb_src[-max_w+0].r
                             + rgb_src[-max_w+1].r
                             + rgb_src[      -0].r
                             + rgb_src[       1].r
                             + rgb_src[ max_w-0].r
                             + rgb_src[ max_w+0].r
                             + rgb_src[ max_w+1].r
                            ) * 455
                         + rgb_src[       0].r * 456
                         + 2048
                        ) >> 12
                        : rgb_src[0].r;
            rgb_src++;
            rgb_dst++;
        }
        // [v
        for( int x = 1; x < w-1; x++ )
        {
            rgb_dst->b = ( bBlue ) ?
                        (
                            (  rgb_src[-max_w-1].b
                             + rgb_src[-max_w+0].b
                             + rgb_src[-max_w+1].b
                             + rgb_src[      -1].b
                             + rgb_src[       1].b
                             + rgb_src[ max_w-1].b
                             + rgb_src[ max_w+0].b
                             + rgb_src[ max_w+1].b
                            ) * 455
                         + rgb_src[       0].b * 456
                         + 2048
                        ) >> 12
                        : rgb_src[0].b;
            rgb_dst->g = ( bGreen ) ?
                        (
                            (  rgb_src[-max_w-1].g
                             + rgb_src[-max_w+0].g
                             + rgb_src[-max_w+1].g
                             + rgb_src[      -1].g
                             + rgb_src[       1].g
                             + rgb_src[ max_w-1].g
                             + rgb_src[ max_w+0].g
                             + rgb_src[ max_w+1].g
                            ) * 455
                         + rgb_src[       0].g * 456
                         + 2048
                        ) >> 12
                        : rgb_src[0].g;
            rgb_dst->r = ( bRed ) ?
                        (
                            (  rgb_src[-max_w-1].r
                             + rgb_src[-max_w+0].r
                             + rgb_src[-max_w+1].r
                             + rgb_src[      -1].r
                             + rgb_src[       1].r
                             + rgb_src[ max_w-1].r
                             + rgb_src[ max_w+0].r
                             + rgb_src[ max_w+1].r
                            ) * 455
                         + rgb_src[       0].r * 456
                         + 2048
                        ) >> 12
                        : rgb_src[0].r;
            rgb_src++;
            rgb_dst++;
        }
        // E[
        {
            rgb_dst->b = ( bBlue ) ?
                        (
                            (  rgb_src[-max_w-1].b
                             + rgb_src[-max_w+0].b
                             + rgb_src[-max_w+0].b
                             + rgb_src[      -1].b
                             + rgb_src[       0].b
                             + rgb_src[ max_w-1].b
                             + rgb_src[ max_w+0].b
                             + rgb_src[ max_w+0].b
                            ) * 455
                         + rgb_src[       0].b * 456
                         + 2048
                        ) >> 12
                        : rgb_src[0].b;
            rgb_dst->g = ( bGreen ) ?
                        (
                            (  rgb_src[-max_w-1].g
                             + rgb_src[-max_w+0].g
                             + rgb_src[-max_w+0].g
                             + rgb_src[      -1].g
                             + rgb_src[       0].g
                             + rgb_src[ max_w-1].g
                             + rgb_src[ max_w+0].g
                             + rgb_src[ max_w+0].g
                            ) * 455
                         + rgb_src[       0].g * 456
                         + 2048
                        ) >> 12
                        : rgb_src[0].g;
            rgb_dst->r = ( bRed ) ?
                        (
                            (  rgb_src[-max_w-1].r
                             + rgb_src[-max_w+0].r
                             + rgb_src[-max_w+0].r
                             + rgb_src[      -1].r
                             + rgb_src[       0].r
                             + rgb_src[ max_w-1].r
                             + rgb_src[ max_w+0].r
                             + rgb_src[ max_w+0].r
                            ) * 455
                         + rgb_src[       0].r * 456
                         + 2048
                        ) >> 12
                        : rgb_src[0].r;
        }
    }

    // ŏIԖڂ̃XbhȂԏ̃C
    if( thread_id == thread_num - 1 )
    {
        const PIXEL *rgb_src = (PIXEL *)fpip->ycp_edit + (h - 1) * max_w;
        PIXEL *rgb_dst = (PIXEL *)fpip->ycp_temp + (h - 1) * max_w;
        // ԍ
        {
            rgb_dst->b = ( bBlue ) ?
                        (
                            (  rgb_src[-max_w-0].b
                             + rgb_src[-max_w+0].b
                             + rgb_src[-max_w+1].b
                             + rgb_src[      -0].b
                             + rgb_src[       1].b
                             + rgb_src[      -0].b
                             + rgb_src[      +0].b
                             + rgb_src[      +1].b
                            ) * 455
                         + rgb_src[       0].b * 456
                         + 2048
                        ) >> 12
                        : rgb_src[0].b ;
            rgb_dst->g = ( bGreen ) ?
                        (
                            (  rgb_src[-max_w-0].g
                             + rgb_src[-max_w+0].g
                             + rgb_src[-max_w+1].g
                             + rgb_src[      -0].g
                             + rgb_src[       1].g
                             + rgb_src[      -0].g
                             + rgb_src[      +0].g
                             + rgb_src[      +1].g
                            ) * 455
                         + rgb_src[       0].g * 456
                         + 2048
                        ) >> 12
                        : rgb_src[0].g;
            rgb_dst->r = ( bRed ) ?
                        (
                            (  rgb_src[-max_w-0].r
                             + rgb_src[-max_w+0].r
                             + rgb_src[-max_w+1].r
                             + rgb_src[      -0].r
                             + rgb_src[       1].r
                             + rgb_src[      -0].r
                             + rgb_src[      +0].r
                             + rgb_src[      +1].r
                            ) * 455
                         + rgb_src[       0].r * 456
                         + 2048
                        ) >> 12
                        : rgb_src[0].r;
            rgb_src++;
            rgb_dst++;
        }
        // [[[v
        for( int x = 1; x < w-1; x++ )
        {
            rgb_dst->b = ( bBlue ) ?
                        (
                            (  rgb_src[-max_w-1].b
                             + rgb_src[-max_w+0].b
                             + rgb_src[-max_w+1].b
                             + rgb_src[      -1].b
                             + rgb_src[       1].b
                             + rgb_src[      -1].b
                             + rgb_src[      +0].b
                             + rgb_src[      +1].b
                            ) * 455
                         + rgb_src[       0].b * 456
                         + 2048
                        ) >> 12
                        : rgb_src[0].b;
            rgb_dst->g = ( bGreen ) ?
                        (
                            (  rgb_src[-max_w-1].g
                             + rgb_src[-max_w+0].g
                             + rgb_src[-max_w+1].g
                             + rgb_src[      -1].g
                             + rgb_src[       1].g
                             + rgb_src[      -1].g
                             + rgb_src[      +0].g
                             + rgb_src[      +1].g
                            ) * 455
                         + rgb_src[       0].g * 456
                         + 2048
                        ) >> 12
                        : rgb_src[0].g;
            rgb_dst->r = ( bRed ) ?
                        (
                            (  rgb_src[-max_w-1].r
                             + rgb_src[-max_w+0].r
                             + rgb_src[-max_w+1].r
                             + rgb_src[      -1].r
                             + rgb_src[       1].r
                             + rgb_src[      -1].r
                             + rgb_src[      +0].r
                             + rgb_src[      +1].r
                            ) * 455
                         + rgb_src[       0].r * 456
                         + 2048
                        ) >> 12
                        : rgb_src[0].r;
            rgb_src++;
            rgb_dst++;
        }
        // ԉE
        {
            rgb_dst->b = ( bBlue ) ?
                        (
                            (  rgb_src[-max_w-1].b
                             + rgb_src[-max_w+0].b
                             + rgb_src[-max_w+0].b
                             + rgb_src[      -1].b
                             + rgb_src[       0].b
                             + rgb_src[      -1].b
                             + rgb_src[      +0].b
                             + rgb_src[      +0].b
                            ) * 455
                         + rgb_src[       0].b * 456
                         + 2048
                        ) >> 12
                        : rgb_src[0].b;
            rgb_dst->g = ( bGreen ) ?
                        (
                            (  rgb_src[-max_w-1].g
                             + rgb_src[-max_w+0].g
                             + rgb_src[-max_w+0].g
                             + rgb_src[      -1].g
                             + rgb_src[       0].g
                             + rgb_src[      -1].g
                             + rgb_src[      +0].g
                             + rgb_src[      +0].g
                            ) * 455
                         + rgb_src[       0].g * 456
                         + 2048
                        ) >> 12
                        : rgb_src[0].g;
            rgb_dst->r = ( bRed ) ?
                        (
                            (  rgb_src[-max_w-1].r
                             + rgb_src[-max_w+0].r
                             + rgb_src[-max_w+0].r
                             + rgb_src[      -1].r
                             + rgb_src[       0].r
                             + rgb_src[      -1].r
                             + rgb_src[      +0].r
                             + rgb_src[      +0].r
                            ) * 455
                         + rgb_src[       0].r * 456
                         + 2048
                        ) >> 12
                        : rgb_src[0].r;
        }
    }
}

//---------------------------------------------------------------------
// Xbh:RAGAB̊eCʁXɊg債A
//---------------------------------------------------------------------
void __attribute__((force_align_arg_pointer)) thread_fringe( int thread_id, int thread_num, void *param1, void *param2 )
{
    const FILTER *fp              = (FILTER *)param1;
    const FILTER_PROC_INFO *fpip  = (FILTER_PROC_INFO *)param2;

    const int w       = fpip->w;
    const int h       = fpip->h;
    const int max_w   = fpip->max_w;
    const int loop_w  = (w +1) / 2;
    const int loop_h  = (h +1) / 2;

    // Xbhloop_h葽璲
    if( thread_num > loop_h ) thread_num = loop_h;
    if( thread_id >= thread_num || thread_id < 0 ) return;

    // Xbh̉摜郉CvZ
    const int y_start = (loop_h *  thread_id     ) / thread_num;
    const int y_end   = (loop_h * (thread_id + 1)) / thread_num;

    const PIXEL *rgb = (PIXEL *)fpip->ycp_edit;
    PIXEL_YC *ycp = fpip->ycp_temp;

    double center_x = (double)(w + 1) / 2.0;
    double center_y = (double)(h + 1) / 2.0;
    double scale_r_x = (double)w / (double)(w + fp->track[0]);
    double scale_r_y = (double)h / (double)(h + fp->track[1]);
    double scale_g_x = (double)w / (double)(w + fp->track[2]);
    double scale_g_y = (double)h / (double)(h + fp->track[3]);
    double scale_b_x = (double)w / (double)(w + fp->track[4]);
    double scale_b_y = (double)h / (double)(h + fp->track[5]);

    // ㉺EΏ̂Ȃ̂ŁAゾ[v
    for( int y = y_start; y < y_end; y++ )
    {
        for( int x = 0; x < loop_w; x++ )
        {
            double p0, p1, q0, q1;

            // S̋
            double drx = (center_x - (double)x) *  scale_r_x;
            double dry = (center_y - (double)y) *  scale_r_y;
            double dgx = (center_x - (double)x) *  scale_g_x;
            double dgy = (center_y - (double)y) *  scale_g_y;
            double dbx = (center_x - (double)x) *  scale_b_x;
            double dby = (center_y - (double)y) *  scale_b_y;

            int Y0 = 2048, Cb0 = 2048, Cr0 = 2048; // 
            int Y1 = 2048, Cb1 = 2048, Cr1 = 2048; // E
            int Y2 = 2048, Cb2 = 2048, Cr2 = 2048; // 
            int Y3 = 2048, Cb3 = 2048, Cr3 = 2048; // E

            // vZ
            //Y  = ( 19666*R + 38595*G +  7532*B + 2048) >> 12;
            //Cb = (-11105*R - 21792*G + 32897*B + 2048) >> 12;
            //Cr = ( 32897*R - 27525*G -  5372*B + 2048) >> 12;

            // 
            int bx0 = floor(center_x - dbx);
            int bx1 = ceil (center_x - dbx);
            int by0 = floor(center_y - dby);
            int by1 = ceil (center_y - dby);
            p0 = 1.0 - ((center_x - dbx) - floor(center_x - dbx));
            p1 = 1.0 - p0;
            q0 = 1.0 - ((center_y - dby) - floor(center_y - dby));
            q1 = 1.0 - q0;
            double bpq0 = p0 * q0;
            double bpq1 = p1 * q0;
            double bpq2 = p0 * q1;
            double bpq3 = p1 * q1;
            int B0 = (int)( // 
                    (double)rgb[by0*max_w + bx0].b * bpq0 +
                    (double)rgb[by0*max_w + bx1].b * bpq1 +
                    (double)rgb[by1*max_w + bx0].b * bpq2 +
                    (double)rgb[by1*max_w + bx1].b * bpq3
                );
            Y0  +=  7532 * B0;
            Cb0 += 32897 * B0;
            Cr0 += -5372 * B0;
            int B1 = (int)( // E
                    (double)rgb[by0*max_w + (w-bx0-1)].b * bpq0 +
                    (double)rgb[by0*max_w + (w-bx1-1)].b * bpq1 +
                    (double)rgb[by1*max_w + (w-bx0-1)].b * bpq2 +
                    (double)rgb[by1*max_w + (w-bx1-1)].b * bpq3
                );
            Y1  +=  7532 * B1;
            Cb1 += 32897 * B1;
            Cr1 += -5372 * B1;
            int B2 = (int)( // 
                    (double)rgb[(h-by0-1)*max_w + bx0].b * bpq0 +
                    (double)rgb[(h-by0-1)*max_w + bx1].b * bpq1 +
                    (double)rgb[(h-by1-1)*max_w + bx0].b * bpq2 +
                    (double)rgb[(h-by1-1)*max_w + bx1].b * bpq3
                );
            Y2  +=  7532 * B2;
            Cb2 += 32897 * B2;
            Cr2 += -5372 * B2;
            int B3 = (int)( // E
                    (double)rgb[(h-by0-1)*max_w + (w-bx0-1)].b * bpq0 + 
                    (double)rgb[(h-by0-1)*max_w + (w-bx1-1)].b * bpq1 + 
                    (double)rgb[(h-by1-1)*max_w + (w-bx0-1)].b * bpq2 + 
                    (double)rgb[(h-by1-1)*max_w + (w-bx1-1)].b * bpq3
                );
            Y3  +=  7532 * B3;
            Cb3 += 32897 * B3;
            Cr3 += -5372 * B3;

            // 
            int gx0 = floor(center_x - dgx);
            int gx1 = ceil (center_x - dgx);
            int gy0 = floor(center_y - dgy);
            int gy1 = ceil (center_y - dgy);
            p0 = 1.0 - ((center_x - dgx) - floor(center_x - dgx));
            p1 = 1.0 - p0;
            q0 = 1.0 - ((center_y - dgy) - floor(center_y - dgy));
            q1 = 1.0 - q0;
            double gpq0 = p0 * q0;
            double gpq1 = p1 * q0;
            double gpq2 = p0 * q1;
            double gpq3 = p1 * q1;
            int G0 = (int)( // 
                    (double)rgb[gy0*max_w + gx0].g * gpq0 +
                    (double)rgb[gy0*max_w + gx1].g * gpq1 +
                    (double)rgb[gy1*max_w + gx0].g * gpq2 +
                    (double)rgb[gy1*max_w + gx1].g * gpq3
                );
            Y0  +=  38595 * G0;
            Cb0 += -21792 * G0;
            Cr0 += -27525 * G0;
            int G1 = (int)( // E
                    (double)rgb[gy0*max_w + (w-gx0-1)].g * gpq0 +
                    (double)rgb[gy0*max_w + (w-gx1-1)].g * gpq1 +
                    (double)rgb[gy1*max_w + (w-gx0-1)].g * gpq2 +
                    (double)rgb[gy1*max_w + (w-gx1-1)].g * gpq3
                );
            Y1  +=  38595 * G1;
            Cb1 += -21792 * G1;
            Cr1 += -27525 * G1;
            int G2 = (int)( // 
                    (double)rgb[(h-gy0-1)*max_w + gx0].g * gpq0 +
                    (double)rgb[(h-gy0-1)*max_w + gx1].g * gpq1 +
                    (double)rgb[(h-gy1-1)*max_w + gx0].g * gpq2 +
                    (double)rgb[(h-gy1-1)*max_w + gx1].g * gpq3
                );
            Y2  +=  38595 * G2;
            Cb2 += -21792 * G2;
            Cr2 += -27525 * G2;
            int G3 = (int)( // E
                    (double)rgb[(h-gy0-1)*max_w + (w-gx0-1)].g * gpq0 + 
                    (double)rgb[(h-gy0-1)*max_w + (w-gx1-1)].g * gpq1 + 
                    (double)rgb[(h-gy1-1)*max_w + (w-gx0-1)].g * gpq2 + 
                    (double)rgb[(h-gy1-1)*max_w + (w-gx1-1)].g * gpq3
                );
            Y3  +=  38595 * G3;
            Cb3 += -21792 * G3;
            Cr3 += -27525 * G3;

            // 
            int rx0 = floor(center_x - drx);
            int rx1 = ceil (center_x - drx);
            int ry0 = floor(center_y - dry);
            int ry1 = ceil (center_y - dry);
            p0 = 1.0 - ((center_x - drx) - floor(center_x - drx));
            p1 = 1.0 - p0;
            q0 = 1.0 - ((center_y - dry) - floor(center_y - dry));
            q1 = 1.0 - q0;
            double rpq0 = p0 * q0;
            double rpq1 = p1 * q0;
            double rpq2 = p0 * q1;
            double rpq3 = p1 * q1;
            int R0 = (int)( // 
                    (double)rgb[ry0*max_w + rx0].r * rpq0 +
                    (double)rgb[ry0*max_w + rx1].r * rpq1 +
                    (double)rgb[ry1*max_w + rx0].r * rpq2 +
                    (double)rgb[ry1*max_w + rx1].r * rpq3
                );
            Y0  +=  19666 * R0;
            Cb0 += -11105 * R0;
            Cr0 +=  32897 * R0;
            int R1 = (int)( // E
                    (double)rgb[ry0*max_w + (w-rx0-1)].r * rpq0 +
                    (double)rgb[ry0*max_w + (w-rx1-1)].r * rpq1 +
                    (double)rgb[ry1*max_w + (w-rx0-1)].r * rpq2 +
                    (double)rgb[ry1*max_w + (w-rx1-1)].r * rpq3
                );
            Y1  +=  19666 * R1;
            Cb1 += -11105 * R1;
            Cr1 +=  32897 * R1;
            int R2 = (int)( // 
                    (double)rgb[(h-ry0-1)*max_w + rx0].r * rpq0 +
                    (double)rgb[(h-ry0-1)*max_w + rx1].r * rpq1 +
                    (double)rgb[(h-ry1-1)*max_w + rx0].r * rpq2 +
                    (double)rgb[(h-ry1-1)*max_w + rx1].r * rpq3
                );
            Y2  +=  19666 * R2;
            Cb2 += -11105 * R2;
            Cr2 +=  32897 * R2;
            int R3 = (int)( // E
                    (double)rgb[(h-ry0-1)*max_w + (w-rx0-1)].r * rpq0 + 
                    (double)rgb[(h-ry0-1)*max_w + (w-rx1-1)].r * rpq1 + 
                    (double)rgb[(h-ry1-1)*max_w + (w-rx0-1)].r * rpq2 + 
                    (double)rgb[(h-ry1-1)*max_w + (w-rx1-1)].r * rpq3
                );
            Y3  +=  19666 * R3;
            Cb3 += -11105 * R3;
            Cr3 +=  32897 * R3;

            // 
            ycp[y*max_w + x].y  = Y0  >> 12;
            ycp[y*max_w + x].cb = Cb0 >> 12;
            ycp[y*max_w + x].cr = Cr0 >> 12;
            // E
            ycp[y*max_w + (w-x-1)].y  = Y1  >> 12;
            ycp[y*max_w + (w-x-1)].cb = Cb1 >> 12;
            ycp[y*max_w + (w-x-1)].cr = Cr1 >> 12;
            // 
            ycp[(h-y-1)*max_w + x].y  = Y2  >> 12;
            ycp[(h-y-1)*max_w + x].cb = Cb2 >> 12;
            ycp[(h-y-1)*max_w + x].cr = Cr2 >> 12;
            // E
            ycp[(h-y-1)*max_w + (w-x-1)].y  = Y3  >> 12;
            ycp[(h-y-1)*max_w + (w-x-1)].cb = Cb3 >> 12;
            ycp[(h-y-1)*max_w + (w-x-1)].cr = Cr3 >> 12;
        }
    }
}

//---------------------------------------------------------------------
// }`XbhΉo[Wp_~[֐
//---------------------------------------------------------------------
BOOL exec_mtf_dummy( MULTI_THREAD_FUNC fnc, void *param1, void *param2 )
{
    fnc( 0, 1, param1, param2 );
    return TRUE;
}

//---------------------------------------------------------------------
// tB^֐
//---------------------------------------------------------------------
BOOL func_proc( FILTER *fp, FILTER_PROC_INFO *fpip )
{
    // ݒlS0ȂI
    if( fp->track[0] == 0 &&
        fp->track[1] == 0 &&
        fp->track[2] == 0 &&
        fp->track[3] == 0 &&
        fp->track[4] == 0 &&
        fp->track[5] == 0 && 
        !fp->check[0] &&
        !fp->check[1] &&
        !fp->check[2] )
    {
        return TRUE;
    }

    // AviUtl̃}`Xbh֐̑I
    // Ήo[Wł exec_mtf_dummy gp
    BOOL (*exec_mtf)(MULTI_THREAD_FUNC, void*, void*) = fp->exfunc->exec_multi_thread_func ? fp->exfunc->exec_multi_thread_func : exec_mtf_dummy;

    // RGBɕϊ̂tempɍ쐬
    exec_mtf( thread_yc2rgb, fp, fpip );
    {
        // 摜̈̃|C^ւ
        PIXEL_YC *ycp_swap = fpip->ycp_edit;
        fpip->ycp_edit = fpip->ycp_temp;
        fpip->ycp_temp = ycp_swap;
    }

    // ڂ
    if( fp->check[0] || fp->check[1] || fp->check[2] )
    {
        exec_mtf( thread_blur, fp, fpip );
        // 摜̈̃|C^ւ
        PIXEL_YC *ycp_swap = fpip->ycp_edit;
        fpip->ycp_edit = fpip->ycp_temp;
        fpip->ycp_temp = ycp_swap;
    }

    // RGBeC[Ŋg偕YC48ɕϊ
    exec_mtf( thread_fringe, fp, fpip );
    {
        // 摜̈̃|C^ւ
        PIXEL_YC *ycp_swap = fpip->ycp_edit;
        fpip->ycp_edit = fpip->ycp_temp;
        fpip->ycp_temp = ycp_swap;
    }

    return TRUE;
}
